"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from .basesdk import BaseSDK
from mistral_dev import models
from mistral_dev._hooks import HookContext
import mistral_dev.utils as utils
from typing import List, Optional

class Embeddings(BaseSDK):
    r"""Embeddings API"""
    
    
    def create(
        self, *,
        model: Optional[str] = None,
        inputs: Optional[List[str]] = None,
        encoding_format: Optional[models.EncodingFormat] = None,
        server_url: Optional[str] = None,
    ) -> models.EmbeddingResponse:
        r"""Create Embeddings

        :param model: The ID of the model to use for this request.
        :param inputs: The list of strings to embed.
        :param encoding_format: The format of the output data.
        :param server_url: Override the default server URL for this method
        """
        base_url = None
        url_variables = None
        if server_url is not None:
            base_url = server_url
        
        request = models.EmbeddingRequest(
            model=model,
            inputs=inputs,
            encoding_format=encoding_format,
        )
        
        req = self.build_request(
            method="POST",
            path="/embeddings",
            base_url=base_url,
            url_variables=url_variables,
            request=request,
            request_body_required=True,
            request_has_path_params=False,
            request_has_query_params=True,
            user_agent_header="user-agent",
            accept_header_value="application/json",
            security=self.sdk_configuration.security,
            get_serialized_body=lambda: utils.serialize_request_body(request, False, False, "json", models.EmbeddingRequest),
        )
        
        http_res = self.do_request(
            hook_ctx=HookContext(operation_id="createEmbedding", oauth2_scopes=[], security_source=self.sdk_configuration.security),
            request=req,
            error_status_codes=["4XX","5XX"],
        )
        
        
        if http_res.status_code == 200:
            # pylint: disable=no-else-return
            if utils.match_content_type(http_res.headers.get("Content-Type") or "", "application/json"):                
                out = utils.unmarshal_json(http_res.text, Optional[models.EmbeddingResponse])
                return out
            
            content_type = http_res.headers.get("Content-Type")
            raise models.SDKError(f"unknown content-type received: {content_type}", http_res.status_code, http_res.text, http_res)
        elif http_res.status_code >= 400 and http_res.status_code < 500 or http_res.status_code >= 500 and http_res.status_code < 600:
            raise models.SDKError("API error occurred", http_res.status_code, http_res.text, http_res)
        else:
            raise models.SDKError("unknown status code received", http_res.status_code, http_res.text, http_res)
    
    
    async def create_async(
        self, *,
        model: Optional[str] = None,
        inputs: Optional[List[str]] = None,
        encoding_format: Optional[models.EncodingFormat] = None,
        server_url: Optional[str] = None,
    ) -> models.EmbeddingResponse:
        r"""Create Embeddings

        :param model: The ID of the model to use for this request.
        :param inputs: The list of strings to embed.
        :param encoding_format: The format of the output data.
        :param server_url: Override the default server URL for this method
        """
        base_url = None
        url_variables = None
        if server_url is not None:
            base_url = server_url
        
        request = models.EmbeddingRequest(
            model=model,
            inputs=inputs,
            encoding_format=encoding_format,
        )
        
        req = self.build_request(
            method="POST",
            path="/embeddings",
            base_url=base_url,
            url_variables=url_variables,
            request=request,
            request_body_required=True,
            request_has_path_params=False,
            request_has_query_params=True,
            user_agent_header="user-agent",
            accept_header_value="application/json",
            security=self.sdk_configuration.security,
            get_serialized_body=lambda: utils.serialize_request_body(request, False, False, "json", models.EmbeddingRequest),
        )
        
        http_res = await self.do_request_async(
            hook_ctx=HookContext(operation_id="createEmbedding", oauth2_scopes=[], security_source=self.sdk_configuration.security),
            request=req,
            error_status_codes=["4XX","5XX"],
        )
        
        
        if http_res.status_code == 200:
            # pylint: disable=no-else-return
            if utils.match_content_type(http_res.headers.get("Content-Type") or "", "application/json"):                
                out = utils.unmarshal_json(http_res.text, Optional[models.EmbeddingResponse])
                return out
            
            content_type = http_res.headers.get("Content-Type")
            raise models.SDKError(f"unknown content-type received: {content_type}", http_res.status_code, http_res.text, http_res)
        elif http_res.status_code >= 400 and http_res.status_code < 500 or http_res.status_code >= 500 and http_res.status_code < 600:
            raise models.SDKError("API error occurred", http_res.status_code, http_res.text, http_res)
        else:
            raise models.SDKError("unknown status code received", http_res.status_code, http_res.text, http_res)
    
