"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from mistral_dev.types import BaseModel, Nullable
from pydantic import model_serializer
from typing import List, Optional, TypedDict
from typing_extensions import NotRequired


class FIMCompletionResponseRole(str, Enum):
    USER = "user"
    ASSISTANT = "assistant"


class FIMCompletionResponseMessageTypedDict(TypedDict):
    role: NotRequired[FIMCompletionResponseRole]
    content: NotRequired[str]
    

class FIMCompletionResponseMessage(BaseModel):
    role: Optional[FIMCompletionResponseRole] = None
    content: Optional[str] = None
    

class FIMCompletionResponseFinishReason(str, Enum):
    STOP = "stop"
    LENGTH = "length"
    MODEL_LENGTH = "model_length"
    ERROR = "error"


class FIMCompletionResponseChoicesTypedDict(TypedDict):
    index: int
    finish_reason: Nullable[FIMCompletionResponseFinishReason]
    message: NotRequired[FIMCompletionResponseMessageTypedDict]
    

class FIMCompletionResponseChoices(BaseModel):
    index: int
    finish_reason: Nullable[FIMCompletionResponseFinishReason]
    message: Optional[FIMCompletionResponseMessage] = None
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["message"]
        nullable_fields = ["finish_reason"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        

class FIMCompletionResponseUsageTypedDict(TypedDict):
    prompt_tokens: int
    completion_tokens: int
    total_tokens: int
    

class FIMCompletionResponseUsage(BaseModel):
    prompt_tokens: int
    completion_tokens: int
    total_tokens: int
    

class FIMCompletionResponseTypedDict(TypedDict):
    id: NotRequired[str]
    object: NotRequired[str]
    created: NotRequired[int]
    model: NotRequired[str]
    choices: NotRequired[List[FIMCompletionResponseChoicesTypedDict]]
    usage: NotRequired[FIMCompletionResponseUsageTypedDict]
    

class FIMCompletionResponse(BaseModel):
    id: Optional[str] = None
    object: Optional[str] = None
    created: Optional[int] = None
    model: Optional[str] = None
    choices: Optional[List[FIMCompletionResponseChoices]] = None
    usage: Optional[FIMCompletionResponseUsage] = None
    
