"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from .finetuneablemodel import FineTuneableModel
from .trainingparameters import TrainingParameters, TrainingParametersTypedDict
from .wandbintegration import WandbIntegration, WandbIntegrationTypedDict
from mistral_dev.types import BaseModel
from typing import List, Optional, TypedDict
from typing_extensions import NotRequired


class JobInTypedDict(TypedDict):
    model: FineTuneableModel
    r"""The name of the model to fine-tune."""
    training_files: List[str]
    r"""A list containing the IDs of uploaded files that contain training data."""
    hyperparameters: TrainingParametersTypedDict
    r"""The fine-tuning hyperparameter settings used in a fine-tune job."""
    validation_files: NotRequired[List[str]]
    r"""A list containing the IDs of uploaded files that contain validation data.

    If you provide these files, the data is used to generate validation metrics
    periodically during fine-tuning. These metrics can be viewed in `checkpoints`
    when getting the status of a running fine-tuning job.

    The same data should not be present in both train and validation files.

    """
    suffix: NotRequired[str]
    r"""A string that will be added to your fine-tuning model name.
    For example, a suffix of \"my-great-model\" would produce a model
    name like `ft:open-mistral-7b:my-great-model:xxx...`

    """
    integrations: NotRequired[List[WandbIntegrationTypedDict]]
    r"""A list of integrations to enable for your fine-tuning job."""
    

class JobIn(BaseModel):
    model: FineTuneableModel
    r"""The name of the model to fine-tune."""
    training_files: List[str]
    r"""A list containing the IDs of uploaded files that contain training data."""
    hyperparameters: TrainingParameters
    r"""The fine-tuning hyperparameter settings used in a fine-tune job."""
    validation_files: Optional[List[str]] = None
    r"""A list containing the IDs of uploaded files that contain validation data.

    If you provide these files, the data is used to generate validation metrics
    periodically during fine-tuning. These metrics can be viewed in `checkpoints`
    when getting the status of a running fine-tuning job.

    The same data should not be present in both train and validation files.

    """
    suffix: Optional[str] = None
    r"""A string that will be added to your fine-tuning model name.
    For example, a suffix of \"my-great-model\" would produce a model
    name like `ft:open-mistral-7b:my-great-model:xxx...`

    """
    integrations: Optional[List[WandbIntegration]] = None
    r"""A list of integrations to enable for your fine-tuning job."""
    
